-- xmobar config originally from Vic Fryzel
-- Author: Vic Fryzel
-- Changes by: Sanchayan Maity
-- http://github.com/SanchayanMaity/xmonad-config

-- This is setup for dual 1920x1080 monitors, with the right monitor as primary
Config {
    font = "xft:Ubuntu Mono:size=12:antialias=true",
    bgColor = "#000000",
    fgColor = "#ffffff",
    position = BottomW C 100,
    lowerOnStart = True,
    commands = [
        Run MultiCpu   ["-t",
                        "Cpu: <total0> <total1> <total2> <total3>",
                        "-L","30",
                        "-H","60",
                        "-h","#FFB6B0",
                        "-l","#CEFFAC",
                        "-n","#FFFFCC",
                        "-w","3"] 10,
        Run BatteryP   ["BAT0"]
                       ["-t", "<acstatus><watts> (<left>%)",
                        "-L", "10", "-H", "80", "-p", "3",
                        "--", "-O", "<fc=green>On</fc> - ", "-i", "",
                        "-L", "-15", "-H", "-5",
                        "-l", "red", "-m", "blue", "-h", "green"] 600,
        Run Memory     ["-t",
                        "Mem: <usedratio>%",
                        "-H","8192",
                        "-L","4096",
                        "-h","#FFB6B0",
                        "-l","#CEFFAC",
                        "-n","#FFFFCC"] 10,
        Run Swap       ["-t",
                        "Swap: <usedratio>%",
                        "-H","1024",
                        "-L","512",
                        "-h","#FFB6B0",
                        "-l","#CEFFAC",
                        "-n","#FFFFCC"] 10,
        Run Date        "%a %b %_d %l:%M" "date" 10,
        Run StdinReader
    ],
    sepChar = "%",
    alignSep = "}{",
    template = "%StdinReader% }{ %multicpu%   %battery%    %memory%   %swap%   <fc=#FFFFCC>%date%</fc>"
}
